stages:
  - build
  - test
  - deploy

variables:
  DOCKER_DRIVER: overlay2

# Use an image that includes Docker
image: docker:latest

services:
  - docker:dind

# Build the Docker image
build:
  stage: build
  script:
    - docker build -t $CI_REGISTRY_IMAGE:latest .
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - docker push $CI_REGISTRY_IMAGE:latest
  only:
    - main

# Run tests (you need to add your tests here)
test:
  stage: test
  script:
    - echo "Running tests"
    - docker pull $CI_REGISTRY_IMAGE:latest
    - docker run --rm $CI_REGISTRY_IMAGE:latest pytest /app/tests/
  only:
    - merge_requests
    - main

# Deploy to Kubernetes
deploy:
  stage: deploy
  script:
    - echo "Deploying to Kubernetes"
    - kubectl apply -f k8s/deployment.yaml
  only:
    - main
  environment:
    name: test
